function [f_in_x0] = Fct_build_f_inxnpoint_80211az(x0,AP_positions, c, start_time, forward_time)
% Build the observables in x0 point, no noise
%AP_positions = N_AP x 3 matrix with each row showing the x,y,z coordinates
%               of the ap-th access point
%c             = speed of light at the level used in the main file, e.g. in
%                m/ns
N_AP=size(AP_positions, 1);
dif_vect=zeros(N_AP,3);
dif_ap_vect=zeros(N_AP,3);
f_in_x0=zeros(1,N_AP);
% Calculating the observables
sum_of_distancesAP=0;
for i=1:N_AP
    dif_vect(i,:)=x0-AP_positions(i,:); %distance between AP i and MS
    if i>1,
        dif_ap_vect(i,:)=AP_positions(i,:)-AP_positions(i-1,:);
    else
        dif_ap_vect(i,:)=zeros(1,3);
    end;
    %distance between AP index i and AP index i-1;
    distAPi_APiplus1=sqrt(dif_ap_vect(i,1)^2+dif_ap_vect(i,2)^2+dif_ap_vect(i,3)^2);
    sum_of_distancesAP=sum_of_distancesAP+distAPi_APiplus1;
    %time = start time + forwarding time*(i-1) + sum_of_distancesAP/c +
    %distance between AP i and MS/c
    f_in_x0(i) = start_time +  (i-1)*forward_time+ sum_of_distancesAP/c+ (sqrt(dif_vect(i,1)^2 + dif_vect(i,2)^2 + dif_vect(i,3)^2))/c  ;
end