function varargout = interface(varargin)
% INTERFACE MATLAB code for interface.fig
%      INTERFACE, by itself, creates a new INTERFACE or raises the existing
%      singleton*.
%
%      H = INTERFACE returns the handle to a new INTERFACE or the handle to
%      the existing singleton*.
%
%      INTERFACE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in INTERFACE.M with the given input arguments.
%
%      INTERFACE('Property','Value',...) creates a new INTERFACE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before interface_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to interface_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help interface

% Last Modified by GUIDE v2.5 03-Apr-2017 13:37:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @interface_OpeningFcn, ...
                   'gui_OutputFcn',  @interface_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before interface is made visible.
function interface_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to interface (see VARARGIN)

% Choose default command line output for interface
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes interface wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = interface_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% VARIABLES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function AP_vector_Callback(hObject, eventdata, handles)
% hObject    handle to AP_vector (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of AP_vector as text
%        str2double(get(hObject,'String')) returns contents of AP_vector as a double


% --- Executes during object creation, after setting all properties.
function AP_vector_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AP_vector (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function iterations_Callback(hObject, eventdata, handles)
% hObject    handle to iterations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iterations as text
%        str2double(get(hObject,'String')) returns contents of iterations as a double


% --- Executes during object creation, after setting all properties.
function iterations_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iterations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in study_case.
function study_case_Callback(hObject, eventdata, handles)
% hObject    handle to study_case (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns study_case contents as cell array
%        contents{get(hObject,'Value')} returns selected item from study_case
study_case_considered=get(handles.study_case,'Value');
switch study_case_considered
    case 1 % 'Influence of the variance in angle estimation (LOS)'
        set(handles.var_time_step,'enable','off');
        set(handles.var_time_fin,'enable','off');
        set(handles.var_az_ini,'enable','on');
        set(handles.var_az_step,'enable','on');
        set(handles.var_az_fin,'enable','on');
        set(handles.var_elev_ini,'enable','on');
        set(handles.var_elev_step,'enable','on');
        set(handles.var_elev_fin,'enable','on');        
        set(handles.mean_value_ini,'enable','off');
        set(handles.mean_value_step,'enable','off');
        set(handles.mean_value_fin,'enable','off');
        set(handles.mean_azimuth_ini,'enable','off');
        set(handles.mean_azimuth_step,'enable','off');
        set(handles.mean_azimuth_fin,'enable','off');
        set(handles.mean_elevation_ini,'enable','off');
        set(handles.mean_elevation_step,'enable','off');
        set(handles.mean_elevation_fin,'enable','off');

    case 2 % 'Influence of the variance in time estimation (LOS)'
        set(handles.var_time_step,'enable','on');
        set(handles.var_time_fin,'enable','on');
        set(handles.var_az_ini,'enable','on');
        set(handles.var_az_step,'enable','on');
        set(handles.var_az_fin,'enable','on');
        set(handles.var_elev_ini,'enable','off');
        set(handles.var_elev_step,'enable','off');
        set(handles.var_elev_fin,'enable','off');        
        set(handles.mean_value_ini,'enable','off');
        set(handles.mean_value_step,'enable','off');
        set(handles.mean_value_fin,'enable','off');
        set(handles.mean_azimuth_ini,'enable','off');
        set(handles.mean_azimuth_step,'enable','off');
        set(handles.mean_azimuth_fin,'enable','off');
        set(handles.mean_elevation_ini,'enable','off');
        set(handles.mean_elevation_step,'enable','off');
        set(handles.mean_elevation_fin,'enable','off');
        
    case 3 % 'Influence of the elevation variance in the estimation
        set(handles.var_time_ini,'enable','on');
        set(handles.var_time_step,'enable','off');
        set(handles.var_time_fin,'enable','off');
        set(handles.var_az_ini,'enable','on');
        set(handles.var_az_step,'enable','off');
        set(handles.var_az_fin,'enable','off');
        set(handles.var_elev_ini,'enable','on');
        set(handles.var_elev_step,'enable','on');
        set(handles.var_elev_fin,'enable','on');        
        set(handles.mean_value_ini,'enable','off');
        set(handles.mean_value_step,'enable','off');
        set(handles.mean_value_fin,'enable','off');
        set(handles.mean_azimuth_ini,'enable','off');
        set(handles.mean_azimuth_step,'enable','off');
        set(handles.mean_azimuth_fin,'enable','off');
        set(handles.mean_elevation_ini,'enable','on');
        set(handles.mean_elevation_step,'enable','on');
        set(handles.mean_elevation_fin,'enable','on');

    case 4 % 'Influence of the azimuth variance in the estimation
        set(handles.var_time_ini,'enable','on');
        set(handles.var_time_step,'enable','off');
        set(handles.var_time_fin,'enable','off');
        set(handles.var_az_ini,'enable','on');
        set(handles.var_az_step,'enable','on');
        set(handles.var_az_fin,'enable','on');
        set(handles.var_elev_ini,'enable','on');
        set(handles.var_elev_step,'enable','off');
        set(handles.var_elev_fin,'enable','off');        
        set(handles.mean_value_ini,'enable','off');
        set(handles.mean_value_step,'enable','off');
        set(handles.mean_value_fin,'enable','off');
        set(handles.mean_azimuth_ini,'enable','on');
        set(handles.mean_azimuth_step,'enable','on');
        set(handles.mean_azimuth_fin,'enable','on');
        set(handles.mean_elevation_ini,'enable','off');
        set(handles.mean_elevation_step,'enable','off');
        set(handles.mean_elevation_fin,'enable','off');
        
    case 5 % 'Influence of the time variance in the estimation
        set(handles.var_time_ini,'enable','on');
        set(handles.var_time_step,'enable','on');
        set(handles.var_time_fin,'enable','on');
        set(handles.var_az_ini,'enable','on');
        set(handles.var_az_step,'enable','off');
        set(handles.var_az_fin,'enable','off');
        set(handles.var_elev_ini,'enable','on');
        set(handles.var_elev_step,'enable','off');
        set(handles.var_elev_fin,'enable','off');        
        set(handles.mean_value_ini,'enable','on');
        set(handles.mean_value_step,'enable','on');
        set(handles.mean_value_fin,'enable','on');
        set(handles.mean_azimuth_ini,'enable','off');
        set(handles.mean_azimuth_step,'enable','off');
        set(handles.mean_azimuth_fin,'enable','off');
        set(handles.mean_elevation_ini,'enable','off');
        set(handles.mean_elevation_step,'enable','off');
        set(handles.mean_elevation_fin,'enable','off');
        
    case 6 % Influence of the number of APs
        set(handles.var_time_ini,'enable','on');
        set(handles.var_time_step,'enable','off');
        set(handles.var_time_fin,'enable','off');
        set(handles.var_az_ini,'enable','on');
        set(handles.var_az_step,'enable','off');
        set(handles.var_az_fin,'enable','off');
        set(handles.var_elev_ini,'enable','on');
        set(handles.var_elev_step,'enable','off');
        set(handles.var_elev_fin,'enable','off');        
        set(handles.mean_value_ini,'enable','on');
        set(handles.mean_value_step,'enable','off');
        set(handles.mean_value_fin,'enable','off');
        set(handles.mean_azimuth_ini,'enable','on');
        set(handles.mean_azimuth_step,'enable','off');
        set(handles.mean_azimuth_fin,'enable','off');
        set(handles.mean_elevation_ini,'enable','on');
        set(handles.mean_elevation_step,'enable','off');
        set(handles.mean_elevation_fin,'enable','off');

end

% --- Executes during object creation, after setting all properties.
function study_case_CreateFcn(hObject, eventdata, handles)
% hObject    handle to study_case (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function var_time_ini_Callback(hObject, eventdata, handles)
% hObject    handle to var_time_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_time_ini as text
%        str2double(get(hObject,'String')) returns contents of var_time_ini as a double


% --- Executes during object creation, after setting all properties.
function var_time_ini_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_time_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function var_time_step_Callback(hObject, eventdata, handles)
% hObject    handle to var_time_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_time_step as text
%        str2double(get(hObject,'String')) returns contents of var_time_step as a double


% --- Executes during object creation, after setting all properties.
function var_time_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_time_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function var_time_fin_Callback(hObject, eventdata, handles)
% hObject    handle to var_time_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_time_fin as text
%        str2double(get(hObject,'String')) returns contents of var_time_fin as a double


% --- Executes during object creation, after setting all properties.
function var_time_fin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_time_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function var_az_ini_Callback(hObject, eventdata, handles)
% hObject    handle to var_az_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_az_ini as text
%        str2double(get(hObject,'String')) returns contents of var_az_ini as a double


% --- Executes during object creation, after setting all properties.
function var_az_ini_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_az_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function var_az_step_Callback(hObject, eventdata, handles)
% hObject    handle to var_az_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_az_step as text
%        str2double(get(hObject,'String')) returns contents of var_az_step as a double


% --- Executes during object creation, after setting all properties.
function var_az_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_az_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function var_az_fin_Callback(hObject, eventdata, handles)
% hObject    handle to var_az_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_az_fin as text
%        str2double(get(hObject,'String')) returns contents of var_az_fin as a double


% --- Executes during object creation, after setting all properties.
function var_az_fin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_az_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function var_elev_ini_Callback(hObject, eventdata, handles)
% hObject    handle to var_elev_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_elev_ini as text
%        str2double(get(hObject,'String')) returns contents of var_elev_ini as a double


% --- Executes during object creation, after setting all properties.
function var_elev_ini_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_elev_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function var_elev_step_Callback(hObject, eventdata, handles)
% hObject    handle to var_elev_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_elev_step as text
%        str2double(get(hObject,'String')) returns contents of var_elev_step as a double


% --- Executes during object creation, after setting all properties.
function var_elev_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_elev_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function var_elev_fin_Callback(hObject, eventdata, handles)
% hObject    handle to var_elev_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of var_elev_fin as text
%        str2double(get(hObject,'String')) returns contents of var_elev_fin as a double


% --- Executes during object creation, after setting all properties.
function var_elev_fin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_elev_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on selection change in environment.
function environment_Callback(hObject, eventdata, handles)
% hObject    handle to environment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns environment contents as cell array
%        contents{get(hObject,'Value')} returns selected item from environment
type_envir=get(handles.environment,'Value');
switch type_envir
    case 1 % 'NLOS'
        set(handles.mean_value_ini,'enable','on');
        set(handles.mean_value_step,'enable','on');
        set(handles.mean_value_fin,'enable','on');
        set(handles.mean_azimuth_ini,'enable','on');
        set(handles.mean_azimuth_step,'enable','on');
        set(handles.mean_azimuth_fin,'enable','on');
        set(handles.mean_elevation_ini,'enable','on');
        set(handles.mean_elevation_step,'enable','on');
        set(handles.mean_elevation_fin,'enable','on');

    case 2
        set(handles.mean_value_ini,'enable','off');
        set(handles.mean_value_step,'enable','off');
        set(handles.mean_value_fin,'enable','off');
        set(handles.mean_azimuth_ini,'enable','off');
        set(handles.mean_azimuth_step,'enable','off');
        set(handles.mean_azimuth_fin,'enable','off');
        set(handles.mean_elevation_ini,'enable','off');
        set(handles.mean_elevation_step,'enable','off');
        set(handles.mean_elevation_fin,'enable','off');


end

% --- Executes during object creation, after setting all properties.
function environment_CreateFcn(hObject, eventdata, handles)
% hObject    handle to environment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function mean_value_ini_Callback(hObject, eventdata, handles)
% hObject    handle to mean_value_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_value_ini as text
%        str2double(get(hObject,'String')) returns contents of mean_value_ini as a double


% --- Executes during object creation, after setting all properties.
function mean_value_ini_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_value_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function mean_value_step_Callback(hObject, eventdata, handles)
% hObject    handle to mean_value_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_value_step as text
%        str2double(get(hObject,'String')) returns contents of mean_value_step as a double


% --- Executes during object creation, after setting all properties.
function mean_value_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_value_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mean_value_fin_Callback(hObject, eventdata, handles)
% hObject    handle to mean_value_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_value_fin as text
%        str2double(get(hObject,'String')) returns contents of mean_value_fin as a double


% --- Executes during object creation, after setting all properties.
function mean_value_fin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_value_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function mean_azimuth_ini_Callback(hObject, eventdata, handles)
% hObject    handle to mean_azimuth_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_azimuth_ini as text
%        str2double(get(hObject,'String')) returns contents of mean_azimuth_ini as a double


% --- Executes during object creation, after setting all properties.
function mean_azimuth_ini_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_azimuth_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mean_azimuth_step_Callback(hObject, eventdata, handles)
% hObject    handle to mean_azimuth_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_azimuth_step as text
%        str2double(get(hObject,'String')) returns contents of mean_azimuth_step as a double


% --- Executes during object creation, after setting all properties.
function mean_azimuth_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_azimuth_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mean_azimuth_fin_Callback(hObject, eventdata, handles)
% hObject    handle to mean_azimuth_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_azimuth_fin as text
%        str2double(get(hObject,'String')) returns contents of mean_azimuth_fin as a double


% --- Executes during object creation, after setting all properties.
function mean_azimuth_fin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_azimuth_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function mean_elevation_ini_Callback(hObject, eventdata, handles)
% hObject    handle to mean_elevation_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_elevation_ini as text
%        str2double(get(hObject,'String')) returns contents of mean_elevation_ini as a double


% --- Executes during object creation, after setting all properties.
function mean_elevation_ini_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_elevation_ini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mean_elevation_step_Callback(hObject, eventdata, handles)
% hObject    handle to mean_elevation_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_elevation_step as text
%        str2double(get(hObject,'String')) returns contents of mean_elevation_step as a double


% --- Executes during object creation, after setting all properties.
function mean_elevation_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_elevation_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mean_elevation_fin_Callback(hObject, eventdata, handles)
% hObject    handle to mean_elevation_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mean_elevation_fin as text
%        str2double(get(hObject,'String')) returns contents of mean_elevation_fin as a double


% --- Executes during object creation, after setting all properties.
function mean_elevation_fin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mean_elevation_fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mobile_position_Callback(hObject, eventdata, handles)
% hObject    handle to mobile_position (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mobile_position as text
%        str2double(get(hObject,'String')) returns contents of mobile_position as a double


% --- Executes during object creation, after setting all properties.
function mobile_position_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mobile_position (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mobile_estimated_joint_Callback(hObject, eventdata, handles)
% hObject    handle to mobile_estimated_joint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mobile_estimated_joint as text
%        str2double(get(hObject,'String')) returns contents of mobile_estimated_joint as a double


% --- Executes during object creation, after setting all properties.
function mobile_estimated_joint_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mobile_estimated_joint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function dist_err_joint_Callback(hObject, eventdata, handles)
% hObject    handle to dist_err_joint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dist_err_joint as text
%        str2double(get(hObject,'String')) returns contents of dist_err_joint as a double


% --- Executes during object creation, after setting all properties.
function dist_err_joint_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dist_err_joint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function mobile_estimated_time_Callback(hObject, eventdata, handles)
% hObject    handle to mobile_estimated_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mobile_estimated_time as text
%        str2double(get(hObject,'String')) returns contents of mobile_estimated_time as a double


% --- Executes during object creation, after setting all properties.
function mobile_estimated_time_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mobile_estimated_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function dist_err_time_Callback(hObject, eventdata, handles)
% hObject    handle to dist_err_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dist_err_time as text
%        str2double(get(hObject,'String')) returns contents of dist_err_time as a double


% --- Executes during object creation, after setting all properties.
function dist_err_time_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dist_err_time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Simulation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in Simulate.
function Simulate_Callback(hObject, eventdata, handles)
% hObject    handle to Simulate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


AP_study=str2double(get(handles.AP_vector,'String'));
N_iter=str2double(get(handles.iterations,'String'));

% The minimun AP can be considered is 3. Starting from that simple
% structure:
AP_min=3;
% Num_AP=[AP_min:AP_study]; % Array containing the Numbers of APs to consider in each realization of the study

% Variances values
var_t_ini=str2double(get(handles.var_time_ini,'String'));
var_t_step=str2double(get(handles.var_time_step,'String'));
var_t_fin=str2double(get(handles.var_time_fin,'String'));

var_az_ini=str2double(get(handles.var_az_ini,'String'));
var_az_step=str2double(get(handles.var_az_step,'String'));
var_az_fin=str2double(get(handles.var_az_fin,'String'));

var_elev_ini=str2double(get(handles.var_elev_ini,'String'));
var_elev_step=str2double(get(handles.var_elev_step,'String'));
var_elev_fin=str2double(get(handles.var_elev_fin,'String'));

% Creating each variance vector (time, azimuth and elevation)
var_t_vect=[var_t_ini:var_t_step:var_t_fin];
var_az_vect=[var_az_ini:var_az_step:var_az_fin];
var_elev_vect=[var_elev_ini:var_elev_step:var_elev_fin];

% Median value according to the study case considered
type_envir=get(handles.environment,'Value');


cla % resets all the axes
v=handles.building; % handle that we pass through the function to represent on the axes of the interface the building and the position of AP's and mobile

% Iniatialize the generator
rng(0,'twister');

% Vectors used in the following cases
str_cat=[];
str_cat2=[];
vect_iter=[];
vect_dist_err_joint=[];
vect_dist_err_time=[];

% Depending on the case under study the results plotted will be different
env_study=get(handles.study_case,'Value');

% Initializing stop button to 0
set(handles.stop,'UserData',0); 

switch env_study
    case 1 % 'Influence of the angles variance the estimation (LOS)'
        % Path where we want to save results
        mkdir('Case_1:Variance_angle_influence');
        path=[pwd '/Case_1:Variance_angle_influence/'];
        
        mu_t=0;
        mu_az=0;
        mu_elev=0;

        var_t=var_t_ini; % We will consider the time variance constant
        
        % In this case, the purpose is to study how varying the value of
        % the variance of the angles affects to estimation error. For this
        % purpose, we will vary the variance of the azimuth and elevation
        % angle to each AP.
        
        % Progress
        progress=0;
        set(handles.progress,'String',progress);
        % Total iterations
        total=length(var_az_vect)*length(var_elev_vect)*N_iter;
        
        N_AP=AP_study
        for vr_a=1:length(var_az_vect) % Length of var_az y var_elev can be different! keep it mind
            var_az=var_az_vect(vr_a);
            if get(handles.stop,'UserData')==1
                warndlg('FORCED EXIT');
                display('!!!!!!!! FORCED EXIT !!!!!!!!');
                break
            end
            for vr_e=1:length(var_elev_vect)
                var_elev=var_elev_vect(vr_e); 
                if get(handles.stop,'UserData')==1
                    break
                end
                for iter=1:N_iter
                    if get(handles.stop,'UserData')==1
                     break
                    end
                    
                    cla(handles.building); % reset only building axes
                    [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);
                    

                    % Putting the results in the results text boxes
                    set(handles.AP,'String',N_AP);
                    set(handles.iteration,'String',iter);
                    set(handles.variance_time,'String',var_t);
                    set(handles.variance_azimuth_angle,'String',var_az);
                    set(handles.variance_elevation_angle,'String',var_elev);
                    set(handles.mean_time_value_interface,'String',mu_t);
                    set(handles.mean_azimuth_angle_value,'String',mu_az);
                    set(handles.mean_elevation_angle_value,'String',mu_elev);
                    set(handles.mobile_coord,'String',mvl);
                    set(handles.est_time_coord,'String',xest1);
                    set(handles.est_angle_coord,'String',xest2);
                    set(handles.est_joint_coord,'String',xest3);
                    set(handles.dist_err_time,'String',dist_err_time);
                    set(handles.dist_err_angle,'String',dist_err_angle);
                    set(handles.dist_err_joint,'String',dist_err_joint);
                    drawnow;
                    dist_err_time_estimation(iter,vr_e)=dist_err_time;
                    dist_err_angle_estimation(iter,vr_e)=dist_err_angle;
                    dist_err_joint_estimation(iter,vr_e)=dist_err_joint; % Matrix of N_iter x N_var_elev_angles
                   
                end
                progress=(iter*vr_e*vr_a/total)*100;
                set(handles.progress,'String',progress);
            end
            mean_dist_err_joint_estimation_angles(vr_a,:)=nanmean(dist_err_joint_estimation); % Matrix of N_var_az_angles x N_var_elev_angles
            mean_dist_err_time_estimation_angles(vr_a,:)=nanmean(dist_err_time_estimation);
            mean_dist_err_angle_estimation_angles(vr_a,:)=nanmean(dist_err_angle_estimation);
            std_dist_err_joint_estimation_angles(vr_a,:)=nanstd(dist_err_joint_estimation);
            std_dist_err_time_estimation_angles(vr_a,:)=nanstd(dist_err_time_estimation);
            std_dist_err_angle_estimation_angles(vr_a,:)=nanstd(dist_err_angle_estimation);
        end
        
        [x,y]=meshgrid(var_elev_vect,var_az_vect); % x - contains the values of var_elev_vect, size N_var_az_angles x N_var_elev_angles

        h=figure(env_study);
        subplot(211)
        surf(x,y,mean_dist_err_time_estimation_angles);
        grid on
        xlabel('\sigma_\theta')
        ylabel('\sigma_\alpha')
        zlabel('Average Error (m)')
        legend(['AP ',num2str(N_AP),' Time Variance ', num2str(var_t)]);
        title('Distance error using TOA estimation');
        
        subplot(212)
        surf(x,y,mean_dist_err_angle_estimation_angles);
        grid on
        xlabel('\sigma_\theta')
        ylabel('\sigma_\alpha')
        zlabel('Average Error (m)')
        legend(['AP ',num2str(N_AP),' Time Variance ', num2str(var_t)]);
        title('Distance error using AOA estimation');
        
%         subplot(313)
%         surf(x,y,mean_dist_err_joint_estimation_angles);
%         hold on
%         grid on
%         xlabel('\sigma_\theta')
%         ylabel('\sigma_\alpha')
%         zlabel('Average Error (m)')
%         legend(['AP ',num2str(N_AP),' Time Variance ', num2str(var_t)]);
%         title('Distance error using TOA+AOA estimation');

        
        h1=figure(env_study+6);
        subplot(211)
        surf(x,y,std_dist_err_time_estimation_angles);
        grid on
        xlabel('\sigma_\theta')
        ylabel('\sigma_\alpha')
        zlabel('Standard Error (m)')
        legend(['AP ',num2str(N_AP),' Time Variance ', num2str(var_t)]);
        title('Distance error using TOA estimation');

        subplot(212)
        surf(x,y,std_dist_err_angle_estimation_angles);
        grid on
        xlabel('\sigma_\theta')
        ylabel('\sigma_\alpha')
        zlabel('Standard Error (m)')
        legend(['AP ',num2str(N_AP),' Time Variance ', num2str(var_t)]);
        title('Distance error using AOA estimation');
        
%         subplot(313)
%         [x,y]=meshgrid(var_elev_vect,var_az_vect); % x - contains the values of var_elev_vect, size N_var_az_angles x N_var_elev_angles
%         surf(x,y,std_dist_err_joint_estimation_angles);
%         hold on
%         grid on
%         xlabel('\sigma_\theta')
%         ylabel('\sigma_\alpha')
%         zlabel('Standard Error (m)')
%         legend(['AP ',num2str(N_AP),' Time Variance ', num2str(var_t)]);
%         title('Distance error using TOA+AOA estimation');

        
        % Save the figure
        figname=horzcat('AP',num2str(N_AP),'_Avg_Est_Error_Time_Variance_',num2str(var_t),'.fig');
        saveas(h,fullfile(path,figname),'fig');
        figname=horzcat('AP',num2str(N_AP),'_Std_Est_Error_Time_Variance_',num2str(var_t),'.fig');
        saveas(h1,fullfile(path,figname),'fig');

        % Closing the figure for not overloading the screen. All the
        % figures are saved in its own directory.
        close(h)
        close(h1)

        % We want to obtain the value of theta and alpha that gives an
        % error less than 5 m; 1 m and 0.5 m. Therefore, we save in ws the
        % tables containing the error per each value of the azimuth and
        % elevation variance.

        Table_joint_est_avg_error=table(mean_dist_err_joint_estimation_angles);
        Table_joint_est_std_error=table(std_dist_err_joint_estimation_angles);
        Table_time_est_avg_error=table(mean_dist_err_time_estimation_angles);
        Table_time_est_std_error=table(std_dist_err_time_estimation_angles);
        Table_angle_est_avg_error=table(mean_dist_err_angle_estimation_angles);
        Table_angle_est_std_error=table(std_dist_err_angle_estimation_angles);
        P=genvarname(['AP',num2str(N_AP),'_joint_est_avg_error']);
        assignin('base',P,Table_joint_est_avg_error); % save in worksapce
        P2=genvarname(['AP',num2str(N_AP),'_joint_est_std_error']);
        assignin('base',P2,Table_joint_est_std_error); % save in worksapce
        P3=genvarname(['AP',num2str(N_AP),'_time_est_avg_error']);
        assignin('base',P3,Table_time_est_avg_error); % save in worksapce
        P4=genvarname(['AP',num2str(N_AP),'_time_est_std_error']);
        assignin('base',P4,Table_time_est_std_error); % save in worksapce
        P5=genvarname(['AP',num2str(N_AP),'_angle_est_avg_error']);
        assignin('base',P5,Table_angle_est_avg_error); % save in worksapce
        P6=genvarname(['AP',num2str(N_AP),'_angle_est_std_error']);
        assignin('base',P6,Table_angle_est_std_error); % save in worksapce
        writetable(Table_joint_est_avg_error,fullfile(path,P),'Delimiter',',');
        writetable(Table_joint_est_std_error,fullfile(path,P2),'Delimiter',',');
        writetable(Table_time_est_avg_error,fullfile(path,P3),'Delimiter',',');
        writetable(Table_time_est_std_error,fullfile(path,P4),'Delimiter',',');
        writetable(Table_angle_est_avg_error,fullfile(path,P5),'Delimiter',',');
        writetable(Table_angle_est_std_error,fullfile(path,P6),'Delimiter',',');
        
        % We can also write the command "readtable('file.txt')" to display
       % the tables
       
       
    case 2 % 'Influence of the time variance in the estimation (LOS)'
        % Path where we want to save results
        mkdir('Case_2:Variance_time_influence');
        path=[pwd '/Case_2:Variance_time_influence/'];
        
        mu_t=0;
        mu_az=0;
        mu_elev=0;
        
        % In this case, the purpose is to study how varying the value of
        % the time variance considering the variance
        % azimuth=variance elevation affects to the estimation error. 
%         var_az_elev_vect=[0:0.1:2*pi]; % Variation will be in azimuth and elevation angle
        var_az_elev_vect=var_az_vect; % Variation will be in azimuth and elevation angle
        
        N_AP=AP_study;
        
        % Progress
        progress=0;
        set(handles.progress,'String',progress);
        % Total iterations
        total=length(var_t_vect)*length(var_az_elev_vect)*N_iter;
        
        for vr_t=1:length(var_t_vect) 
            var_t=var_t_vect(vr_t);
            if get(handles.stop,'UserData')==1
                warndlg('FORCED EXIT');
                display('!!!!!!!! FORCED EXIT !!!!!!!!');
                break
            end
            for vr_az_elev=1:length(var_az_elev_vect) % Length of var_az y var_elev has to be the same in this case! keep it mind
                var_az=var_az_elev_vect(vr_az_elev);
                var_elev=var_az; % variance in elevation is the same than variance in azimuth
                if get(handles.stop,'UserData')==1
                    break
                end
                for iter=1:N_iter
                    if get(handles.stop,'UserData')==1
                     break
                    end
                    
                    cla(handles.building); % reset only building axes
                    [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);

                    set(handles.AP,'String',N_AP);
                    set(handles.iteration,'String',iter);
                    set(handles.variance_time,'String',var_t);
                    set(handles.variance_azimuth_angle,'String',var_az);
                    set(handles.variance_elevation_angle,'String',var_elev);
                    set(handles.mean_time_value_interface,'String',mu_t);
                    set(handles.mean_azimuth_angle_value,'String',mu_az);
                    set(handles.mean_elevation_angle_value,'String',mu_elev);
                    set(handles.mobile_coord,'String',mvl);
                    set(handles.est_time_coord,'String',xest1);
                    set(handles.est_angle_coord,'String',xest2);
                    set(handles.est_joint_coord,'String',xest3);
                    set(handles.dist_err_time,'String',dist_err_time);
                    set(handles.dist_err_angle,'String',dist_err_angle);
                    set(handles.dist_err_joint,'String',dist_err_joint);
                    drawnow;
                    dist_err_time_estimation(iter,vr_az_elev)=dist_err_time;
                    dist_err_angle_estimation(iter,vr_az_elev)=dist_err_angle;
                    dist_err_joint_estimation(iter,vr_az_elev)=dist_err_joint; % Matrix of N_iter x N_var_elev_angles
                end
                progress=(iter*vr_az_elev*vr_t/total)*100;
                set(handles.progress,'String',progress);
            end
            mean_dist_err_joint_variances(vr_t,:)=nanmean(dist_err_joint_estimation); % Matrix of N_var_time x N_var_az_elev_angles
            mean_dist_err_time_variances(vr_t,:)=nanmean(dist_err_time_estimation);  
            mean_dist_err_angle_variances(vr_t,:)=nanmean(dist_err_angle_estimation);  
            std_dist_err_joint_variances(vr_t,:)=nanstd(dist_err_joint_estimation); % Matrix of N_var_time x N_var_az_elev_angles
            std_dist_err_time_variances(vr_t,:)=nanstd(dist_err_time_estimation);    
            std_dist_err_angle_variances(vr_t,:)=nanstd(dist_err_angle_estimation);    
        end
        [x,y]=meshgrid(var_az_elev_vect,var_t_vect); % x - contains the values of var_az_elev_vect. Result is a grid of N_var_t_vect x N_var_az_elev_vect
        h=figure(env_study)
        subplot(211)
        surf(x,y,mean_dist_err_time_variances);
        grid on
        xlabel('\sigma_\alpha = \sigma_\theta')
        ylabel('\sigma_t')
        zlabel('Average Error (m)')
        legend(['AP ',num2str(N_AP)]);
        title('Distance error using TOA estimation');
        
        subplot(212)
        surf(x,y,mean_dist_err_angle_variances);
        grid on
        xlabel('\sigma_\alpha = \sigma_\theta')
        ylabel('\sigma_t')
        zlabel('Average Error (m)')
        legend(['AP ',num2str(N_AP)]);
        title('Distance error using AOA estimation');
        
%         subplot(313)
%         surf(x,y,mean_dist_err_joint_variances); % dist_err_joint_variances is a matrix of N_var_t_vect x N_var_az_elev_vect
%         xlabel('\sigma_\alpha = \sigma_\theta')
%         ylabel('\sigma_t')
%         zlabel('Mean Error (m)')
%         legend(['AP ',num2str(N_AP)]);
%         title('Mean distance error using TOA+AOA estimation');
% 
        
        h1=figure(env_study+6)
        subplot(211)
        surf(x,y,std_dist_err_time_variances);
        grid on
        xlabel('\sigma_\alpha = \sigma_\theta')
        ylabel('\sigma_t')
        zlabel('Standard Error (m)')
        legend(['AP ',num2str(N_AP)]);
        title('Distance error using TOA estimation');
        
        subplot(212)
        surf(x,y,std_dist_err_angle_variances);
        grid on
        xlabel('\sigma_\alpha = \sigma_\theta')
        ylabel('\sigma_t')
        zlabel('Standard Error (m)')
        legend(['AP ',num2str(N_AP)]);
        title('Distance error using AOA estimation');
    
%         subplot(313)
%         surf(x,y,std_dist_err_joint_variances); % dist_err_joint_variances is a matrix of N_var_t_vect x N_var_az_elev_vect
%         xlabel('\sigma_\alpha = \sigma_\theta')
%         ylabel('\sigma_t')
%         zlabel('Standard Error (m)')
%         legend(['AP ',num2str(N_AP)]);
%         title('Distance error using TOA+AOA estimation');

    
        % Save the figure
        figname=horzcat('AP',num2str(N_AP),'_Avg_Error.fig');
        saveas(h,fullfile(path,figname),'fig');
        figname=horzcat('AP',num2str(N_AP),'_Std_Error.fig');
        saveas(h1,fullfile(path,figname),'fig');

        % Closing the figure for not overloading the screen. All the
        % figures are saved in its own directory.
        close(h)
        close(h1)

        % We want to obtain the value of theta and alpha that gives an
        % error less than 5 m; 1 m and 0.5 m. We save the tables containing
        % the error in text file and ws.

        Table_joint_est_avg_error=table(mean_dist_err_joint_variances);
        Table_joint_est_std_error=table(std_dist_err_joint_variances);
        Table_time_est_avg_error=table(mean_dist_err_time_variances);
        Table_time_est_std_error=table(std_dist_err_time_variances);
        Table_angle_est_avg_error=table(mean_dist_err_angle_variances);
        Table_angle_est_std_error=table(std_dist_err_angle_variances);
        P=genvarname(['AP',num2str(N_AP),'_joint_est_avg_error']);
        assignin('base',P,Table_joint_est_avg_error); % save in worksapce
        P2=genvarname(['AP',num2str(N_AP),'_joint_est_std_error']);
        assignin('base',P2,Table_joint_est_std_error); % save in worksapce
        P3=genvarname(['AP',num2str(N_AP),'_time_est_avg_error']);
        assignin('base',P3,Table_time_est_avg_error); % save in worksapce
        P4=genvarname(['AP',num2str(N_AP),'_time_est_std_error']);
        assignin('base',P4,Table_time_est_std_error); % save in worksapce
        P5=genvarname(['AP',num2str(N_AP),'_angle_est_avg_error']);
        assignin('base',P5,Table_angle_est_avg_error); % save in worksapce
        P6=genvarname(['AP',num2str(N_AP),'_angle_est_std_error']);
        assignin('base',P6,Table_angle_est_std_error); % save in worksapce
        writetable(Table_joint_est_avg_error,fullfile(path,P),'Delimiter',',');
        writetable(Table_joint_est_std_error,fullfile(path,P2),'Delimiter',',');
        writetable(Table_time_est_avg_error,fullfile(path,P3),'Delimiter',',');
        writetable(Table_time_est_std_error,fullfile(path,P4),'Delimiter',',');
        writetable(Table_angle_est_avg_error,fullfile(path,P5),'Delimiter',',');
        writetable(Table_angle_est_std_error,fullfile(path,P6),'Delimiter',',');


    case 3 % 'Influence of the mean value in angle estimation (NLOS in elevation)'
        % Path where we want to save results
        mkdir('Case_3:Elevation_angle_influence');
        path=[pwd '/Case_3:Elevation_angle_influence/'];
        
        N_AP=AP_study;
        
        % Time variance and azimuth variance are constant
        var_t=var_t_ini;
        var_az=var_az_ini;   
        
        % Mean values
        mu_t=0;
        mu_az=0;
        
        switch type_envir
            case 1 % 'NLOS'
                mu_elev_ini=str2double(get(handles.mean_elevation_ini,'String'));
                mu_elev_step=str2double(get(handles.mean_elevation_step,'String'));
                mu_elev_fin=str2double(get(handles.mean_elevation_fin,'String'));
                mu_elev_vect=[mu_elev_ini:mu_elev_step:mu_elev_fin];
                
                % Progress
                progress=0;
                set(handles.progress,'String',progress);
                
                % Total iterations
                total=length(var_elev_vect)*length(mu_elev_vect)*N_iter;
                
                for vr_elev=1:length(var_elev_vect) 
                    var_elev=var_elev_vect(vr_elev); 
                    if get(handles.stop,'UserData')==1
                        warndlg('FORCED EXIT');
                        display('!!!!!!!! FORCED EXIT !!!!!!!!');
                        break
                    end
                    for mu=1:length(mu_elev_vect) 
                        mu_elev=mu_elev_vect(mu);
                        if get(handles.stop,'UserData')==1
                            break
                        end
                        for iter=1:N_iter
                            if get(handles.stop,'UserData')==1
                                break
                            end
                            cla(handles.building); % reset only building axes
                            [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);

%                             Putting the results in the results text boxes
                            set(handles.AP,'String',N_AP);
                            set(handles.iteration,'String',iter);
                            set(handles.variance_time,'String',var_t);
                            set(handles.variance_azimuth_angle,'String',var_az);
                            set(handles.variance_elevation_angle,'String',var_elev);
                            set(handles.mean_time_value_interface,'String',mu_t);
                            set(handles.mean_azimuth_angle_value,'String',mu_az);
                            set(handles.mean_elevation_angle_value,'String',mu_elev);
                            set(handles.mobile_coord,'String',mvl);
                            set(handles.est_time_coord,'String',xest1);
                            set(handles.est_angle_coord,'String',xest2);
                            set(handles.est_joint_coord,'String',xest3);
                            set(handles.dist_err_time,'String',dist_err_time);
                            set(handles.dist_err_angle,'String',dist_err_angle);
                            set(handles.dist_err_joint,'String',dist_err_joint);
                            drawnow;
                            dist_err_time_estimation(iter,mu)=dist_err_time;
                            dist_err_angle_estimation(iter,mu)=dist_err_angle;
                            dist_err_joint_estimation(iter,mu)=dist_err_joint; % Matrix of N_iter x N_mu_elev_angles
                                                       
                            
                        end
                        progress=(iter*vr_elev*mu/total)*100;
                        set(handles.progress,'String',progress);
                    end
                    mean_dist_err_joint_variances(vr_elev,:)=nanmean(dist_err_joint_estimation); % Matrix of N_var_elev x N_mu_elev_angles
                    mean_dist_err_time_variances(vr_elev,:)=nanmean(dist_err_time_estimation);  
                    mean_dist_err_angle_variances(vr_elev,:)=nanmean(dist_err_angle_estimation);  
                    std_dist_err_joint_variances(vr_elev,:)=nanstd(dist_err_joint_estimation);
                    std_dist_err_time_variances(vr_elev,:)=nanstd(dist_err_time_estimation);
                    std_dist_err_angle_variances(vr_elev,:)=nanstd(dist_err_angle_estimation);
                    
                    h=figure(env_study);
%                     plot(mu_elev_vect,mean_dist_err_joint_variances(vr_elev,:),':',mu_elev_vect,mean_dist_err_time_variances(vr_elev,:),'--',mu_elev_vect,mean_dist_err_angle_variances(vr_elev,:),'-','LineWidth',2);
                    plot(mu_elev_vect,mean_dist_err_time_variances(vr_elev,:),'--',mu_elev_vect,mean_dist_err_angle_variances(vr_elev,:),'-','LineWidth',2);
                    hold on 
                    grid on
%                     str1=(['Elevation variance ', num2str(var_elev_vect(vr_elev)),' Joint est']);
                    str2=(['Elevation variance ', num2str(var_elev_vect(vr_elev)),'  Time est']);
                    str3=(['Elevation variance ', num2str(var_elev_vect(vr_elev)),' Angle est']);
%                     str=[str1; str2; str3];
                    str=[str2; str3];
                    if length(str)<(29+numel(num2str(var_elev_step))) % Number of characters of the String we want to appear in the legend
                        diff=(29+numel(num2str(var_elev_step)))-length(str);
                        rell=char(zeros(1,diff));
%                         str=[str1 rell; str2 rell; str3 rell];
                        str=[str2 rell; str3 rell];
                    end
                    str_cat=[str_cat; str];
                    legend(str_cat);
                    title('Distance error');
                    xlabel('\mu_\theta');
                    ylabel('Average Error (m)');
                    drawnow;
                    
                    h1=figure(env_study+6);
%                     plot(mu_elev_vect,std_dist_err_joint_variances(vr_elev,:),':',mu_elev_vect,std_dist_err_time_variances(vr_elev,:),'--',mu_elev_vect,std_dist_err_angle_variances(vr_elev,:),'-','LineWidth',2);
                    plot(mu_elev_vect,std_dist_err_time_variances(vr_elev,:),'--',mu_elev_vect,std_dist_err_angle_variances(vr_elev,:),'-','LineWidth',2);
                    hold on 
                    grid on
                    legend(str_cat);
                    title('Distance error');
                    xlabel('\mu_\theta');
                    ylabel('Standard Error (m)');
                    drawnow;
                end
                % Save the figure
                figname=horzcat('AP',num2str(N_AP),'_NLOS_Avg_error.fig');
                saveas(h,fullfile(path,figname),'fig');
                
                figname=horzcat('AP',num2str(N_AP),'_NLOS_Std_error.fig');
                saveas(h1,fullfile(path,figname),'fig');
                
                T_mean_error_joint_estimation=table(mean_dist_err_joint_variances);
                T_mean_error_time_estimation=table(mean_dist_err_time_variances);
                T_mean_error_angle_estimation=table(mean_dist_err_angle_variances);
                P=genvarname(['AP',num2str(N_AP),'_NLOS_joint_estimation_mean_error']);
                P2=genvarname(['AP',num2str(N_AP),'_NLOS_time_estimation_mean_error']);
                P3=genvarname(['AP',num2str(N_AP),'_NLOS_angle_estimation_mean_error']);
                assignin('base',P,T_mean_error_joint_estimation); % save in worksapce
                assignin('base',P2,T_mean_error_time_estimation); % save in worksapce
                assignin('base',P3,T_mean_error_angle_estimation); % save in worksapce
                
                writetable(T_mean_error_joint_estimation,fullfile(path,P),'Delimiter',',');
                writetable(T_mean_error_time_estimation,fullfile(path,P2),'Delimiter',',');
                writetable(T_mean_error_angle_estimation,fullfile(path,P3),'Delimiter',',');
                
                T_std_error_joint_estimation=table(std_dist_err_joint_variances);
                T_std_error_time_estimation=table(std_dist_err_time_variances);
                T_std_error_angle_estimation=table(std_dist_err_angle_variances);
                P=genvarname(['AP',num2str(N_AP),'_NLOS_joint_estimation_std_error']);
                P2=genvarname(['AP',num2str(N_AP),'_NLOS_time_estimation_std_error']);
                P3=genvarname(['AP',num2str(N_AP),'_NLOS_angle_estimation_std_error']);
                assignin('base',P,T_std_error_joint_estimation); % save in worksapce
                assignin('base',P2,T_std_error_time_estimation); % save in worksapce
                assignin('base',P3,T_std_error_angle_estimation); % save in worksapce
                
                writetable(T_std_error_joint_estimation,fullfile(path,P),'Delimiter',',');
                writetable(T_std_error_time_estimation,fullfile(path,P2),'Delimiter',',');
                writetable(T_std_error_angle_estimation,fullfile(path,P3),'Delimiter',',');
                
            case 2 % 'LOS'
                mu_elev=0;
                % Progress
                progress=0;
                set(handles.progress,'String',progress);
                
                % Total iterations
                total=length(var_elev_vect)*N_iter;
                for vr_elev=1:length(var_elev_vect) 
                    var_elev=var_elev_vect(vr_elev); 
                    if get(handles.stop,'UserData')==1
                        warndlg('FORCED EXIT');
                        display('!!!!!!!! FORCED EXIT !!!!!!!!');
                        break
                    end
                    for iter=1:N_iter
                        if get(handles.stop,'UserData')==1
                            break
                        end
                        cla(handles.building); % reset only building axes
                        [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);

                        % Putting the results in the results text boxes
                        set(handles.AP,'String',N_AP);
                        set(handles.iteration,'String',iter);
                        set(handles.variance_time,'String',var_t);
                        set(handles.variance_azimuth_angle,'String',var_az);
                        set(handles.variance_elevation_angle,'String',var_elev);
                        set(handles.mean_time_value_interface,'String',mu_t);
                        set(handles.mean_azimuth_angle_value,'String',mu_az);
                        set(handles.mean_elevation_angle_value,'String',mu_elev);
                        set(handles.mobile_coord,'String',mvl);
                        set(handles.est_time_coord,'String',xest1);
                        set(handles.est_angle_coord,'String',xest2);
                        set(handles.est_joint_coord,'String',xest3);
                        set(handles.dist_err_time,'String',dist_err_time);
                        set(handles.dist_err_angle,'String',dist_err_angle);
                        set(handles.dist_err_joint,'String',dist_err_joint);
                        drawnow;
                        dist_err_time_estimation(iter)=dist_err_time;
                        dist_err_angle_estimation(iter)=dist_err_angle;
                        dist_err_joint_estimation(iter)=dist_err_joint; % Matrix of N_iter x N_mu_elev_angles

                    end
                    progress=(iter*vr_elev/total)*100;
                    set(handles.progress,'String',progress);
                    
                    mean_dist_err_joint_variances(vr_elev)=nanmean(dist_err_joint_estimation); % Matrix of N_var_elev x N_mu_elev_angles
                    mean_dist_err_time_variances(vr_elev)=nanmean(dist_err_time_estimation);   
                    mean_dist_err_angle_variances(vr_elev)=nanmean(dist_err_angle_estimation);    
                    std_dist_err_joint_variances(vr_elev)=nanstd(dist_err_joint_estimation); % Matrix of N_var_elev x N_mu_elev_angles
                    std_dist_err_time_variances(vr_elev)=nanstd(dist_err_time_estimation); 
                    std_dist_err_angle_variances(vr_elev)=nanstd(dist_err_angle_estimation);                 
                end
                
                h=figure(env_study);
                plot(var_elev_vect,mean_dist_err_joint_variances,'k-X',var_elev_vect,mean_dist_err_time_variances,'b-o',var_elev_vect,mean_dist_err_angle_variances,'r-s');
%                 plot(var_elev_vect,mean_dist_err_time_variances,'b-o',var_elev_vect,mean_dist_err_angle_variances,'r-s');
                hold on 
                grid on
                legend('Joint Estimation','Time Estimation','Angle Estimation');
%                 legend('Time Estimation','Angle Estimation');
                title('Distance error vs Elevation Variance');
                xlabel('\theta_\theta');
                ylabel('Average Error (m)');
                drawnow;
                
                h1=figure(env_study+6);
                plot(var_elev_vect,std_dist_err_joint_variances,'k-X',var_elev_vect,std_dist_err_time_variances,'b-o',var_elev_vect,std_dist_err_angle_variances,'r-s');
%                 plot(var_elev_vect,std_dist_err_time_variances,'b-o',var_elev_vect,std_dist_err_angle_variances,'r-s');
                hold on 
                grid on
                legend('Joint Estimation','Time Estimation','Angle Estimation');
%                 legend('Time Estimation','Angle Estimation');
                title('Distance error vs Elevation Variance');
                xlabel('\theta_\theta');
                ylabel('Standard Error (m)');
                drawnow;
                
                % Save the figure
                figname=horzcat('AP',num2str(N_AP),'_LOS_Avg_error.fig');
                saveas(h,fullfile(path,figname),'fig');
                figname=horzcat('AP',num2str(N_AP),'_LOS_Std_error.fig');
                saveas(h1,fullfile(path,figname),'fig');
                
        end   
        % Closing the figure for not overloading the screen. All the
        % figures are saved in its own directory.
        close(h)
        close(h1)
            
        % Reseting string for the legends
        str_cat=[];


    case 4 % 'Influence of the mean value in angle estimation (NLOS in azimuth)'
        % Path where we want to save results
        mkdir('Case_4:Azimuth_angle_influence');
        path=[pwd '/Case_4:Azimuth_angle_influence/'];
        
        N_AP=AP_study;
        
        % Time variance and elevation variance are constant
        var_t=var_t_ini;
        var_elev=var_elev_ini;   
        
        % Mean values
        mu_t=0;
        mu_elev=0;
        switch type_envir
            case 1 % 'NLOS'
                mu_az_ini=str2double(get(handles.mean_azimuth_ini,'String'));
                mu_az_step=str2double(get(handles.mean_azimuth_step,'String'));
                mu_az_fin=str2double(get(handles.mean_azimuth_fin,'String'));
                mu_az_vect=[mu_az_ini:mu_az_step:mu_az_fin];

                % Progress
                progress=0;
                set(handles.progress,'String',progress);
                
                % Total iterations
                total=length(var_az_vect)*length(mu_az_vect)*N_iter;

                for vr_az=1:length(var_az_vect) 
                    var_az=var_az_vect(vr_az); 
                    if get(handles.stop,'UserData')==1
                        warndlg('FORCED EXIT');
                        display('!!!!!!!! FORCED EXIT !!!!!!!!');
                        break
                    end
                    for mu=1:length(mu_az_vect) 
                        mu_az=mu_az_vect(mu);
                        if get(handles.stop,'UserData')==1
                            break
                        end
                        for iter=1:N_iter
                            if get(handles.stop,'UserData')==1
                                break
                            end
                            
                            cla(handles.building); % reset only building axes
                            [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);

                            % Putting the results in the results text boxes
                            set(handles.AP,'String',N_AP);
                            set(handles.iteration,'String',iter);
                            set(handles.variance_time,'String',var_t);
                            set(handles.variance_azimuth_angle,'String',var_az);
                            set(handles.variance_elevation_angle,'String',var_elev);
                            set(handles.mean_time_value_interface,'String',mu_t);
                            set(handles.mean_azimuth_angle_value,'String',mu_az);
                            set(handles.mean_elevation_angle_value,'String',mu_elev);
                            set(handles.mobile_coord,'String',mvl);
                            set(handles.est_time_coord,'String',xest1);
                            set(handles.est_angle_coord,'String',xest2);
                            set(handles.est_joint_coord,'String',xest3);
                            set(handles.dist_err_time,'String',dist_err_time);
                            set(handles.dist_err_angle,'String',dist_err_angle);
                            set(handles.dist_err_joint,'String',dist_err_joint);
                            drawnow;
                            dist_err_time_estimation(iter,mu)=dist_err_time;
                            dist_err_angle_estimation(iter,mu)=dist_err_angle;
                            dist_err_joint_estimation(iter,mu)=dist_err_joint; % Matrix of N_iter x N_mu_elev_angles

                        end
                        progress=(iter*vr_az*mu/total)*100;
                        set(handles.progress,'String',progress);
                    end
                    mean_dist_err_joint_variances(vr_az,:)=nanmean(dist_err_joint_estimation); % Matrix of N_var_az x N_mu_az_angles
                    mean_dist_err_time_variances(vr_az,:)=nanmean(dist_err_time_estimation);  
                    mean_dist_err_angle_variances(vr_az,:)=nanmean(dist_err_angle_estimation);  
                    
                    std_dist_err_joint_variances(vr_az,:)=nanstd(dist_err_joint_estimation); % Matrix of N_var_az x N_mu_az_angles
                    std_dist_err_time_variances(vr_az,:)=nanstd(dist_err_time_estimation); 
                    std_dist_err_angle_variances(vr_az,:)=nanstd(dist_err_angle_estimation); 
                    
                    h=figure(env_study);
%                     plot(mu_az_vect,mean_dist_err_joint_variances(vr_az,:),':',mu_az_vect,mean_dist_err_time_variances(vr_az,:),'--',mu_az_vect,mean_dist_err_angle_variances(vr_az,:),'-','LineWidth',2);
                    plot(mu_az_vect,mean_dist_err_time_variances(vr_az,:),'--',mu_az_vect,mean_dist_err_angle_variances(vr_az,:),'-','LineWidth',2);
                    hold on 
                    grid on
%                     str1=(['Azimuth variance ', num2str(var_az_vect(vr_az)),' Joint est']);
                    str2=(['Azimuth variance ', num2str(var_az_vect(vr_az)),'  Time est']);
                    str3=(['Azimuth variance ', num2str(var_az_vect(vr_az)),' Angle est']);
%                     str=[str1; str2; str3];
                    str=[str2; str3];
                    if length(str)<(27+numel(num2str(var_az_step))) % Number of characters of the String we want to appear in the legend
                        diff=(27+numel(num2str(var_az_step)))-length(str);
                        rell=char(zeros(1,diff));
%                         str=[str1 rell; str2 rell; str3 rell];
                        str=[str2 rell; str3 rell];
                    end
                    str_cat=[str_cat; str];
                    legend(str_cat);
                    title('Distance Error');
                    xlabel('\mu_\alpha');
                    ylabel('Average Error (m)');
                    drawnow;

                    h1=figure(env_study+6);
%                     plot(mu_az_vect,std_dist_err_joint_variances(vr_az,:),':',mu_az_vect,std_dist_err_time_variances(vr_az,:),'--',mu_az_vect,std_dist_err_angle_variances(vr_az,:),'-','LineWidth',2);
                    plot(mu_az_vect,std_dist_err_time_variances(vr_az,:),'--',mu_az_vect,std_dist_err_angle_variances(vr_az,:),'-','LineWidth',2);
                    hold on 
                    grid on
                    legend(str_cat);
                    title('Distance Error');
                    xlabel('\mu_\alpha');
                    ylabel('Standard Error (m)');
                    drawnow;

                end
                % Save the figure
                figname=horzcat('AP',num2str(N_AP),'_NLOS_Avg_error.fig');
                saveas(h,fullfile(path,figname),'fig');

                figname=horzcat('AP',num2str(N_AP),'_NLOS_Std_error.fig');
                saveas(h1,fullfile(path,figname),'fig');
                
                T_mean_error_joint_estimation=table(mean_dist_err_joint_variances);
                T_mean_error_time_estimation=table(mean_dist_err_time_variances);
                T_mean_error_angle_estimation=table(mean_dist_err_angle_variances);
                P=genvarname(['AP',num2str(N_AP),'_NLOS_joint_estimation_mean_error']);
                P2=genvarname(['AP',num2str(N_AP),'_NLOS_time_estimation_mean_error']);
                P3=genvarname(['AP',num2str(N_AP),'_NLOS_angle_estimation_mean_error']);
                assignin('base',P,T_mean_error_joint_estimation); % save in worksapce
                assignin('base',P2,T_mean_error_time_estimation); % save in worksapce
                assignin('base',P3,T_mean_error_angle_estimation); % save in worksapce
                
                writetable(T_mean_error_joint_estimation,fullfile(path,P),'Delimiter',',');
                writetable(T_mean_error_time_estimation,fullfile(path,P2),'Delimiter',',');
                writetable(T_mean_error_angle_estimation,fullfile(path,P3),'Delimiter',',');
                
                T_std_error_joint_estimation=table(std_dist_err_joint_variances);
                T_std_error_time_estimation=table(std_dist_err_time_variances);
                T_std_error_angle_estimation=table(std_dist_err_angle_variances);
                P=genvarname(['AP',num2str(N_AP),'_NLOS_joint_estimation_std_error']);
                P2=genvarname(['AP',num2str(N_AP),'_NLOS_time_estimation_std_error']);
                P3=genvarname(['AP',num2str(N_AP),'_NLOS_angle_estimation_std_error']);
                assignin('base',P,T_std_error_joint_estimation); % save in worksapce
                assignin('base',P2,T_std_error_time_estimation); % save in worksapce
                assignin('base',P3,T_std_error_angle_estimation); % save in worksapce

                writetable(T_std_error_joint_estimation,fullfile(path,P),'Delimiter',',');
                writetable(T_std_error_time_estimation,fullfile(path,P2),'Delimiter',',');
                writetable(T_std_error_angle_estimation,fullfile(path,P3),'Delimiter',',');
                
            case 2 % 'LOS'
                mu_az=0;
                % Progress
                progress=0;
                set(handles.progress,'String',progress);
                
                % Total iterations
                total=length(var_az_vect)*N_iter;
                
                for vr_az=1:length(var_az_vect) 
                    var_az=var_az_vect(vr_az); 
                    for iter=1:N_iter
                        if get(handles.stop,'UserData')==1
                         break
                        end
                        
                        cla(handles.building); % reset only building axes
                        [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);

                        % Putting the results in the results text boxes
                        set(handles.AP,'String',N_AP);
                        set(handles.iteration,'String',iter);
                        set(handles.variance_time,'String',var_t);
                        set(handles.variance_azimuth_angle,'String',var_az);
                        set(handles.variance_elevation_angle,'String',var_elev);
                        set(handles.mean_time_value_interface,'String',mu_t);
                        set(handles.mean_azimuth_angle_value,'String',mu_az);
                        set(handles.mean_elevation_angle_value,'String',mu_elev);
                        set(handles.mobile_coord,'String',mvl);
                        set(handles.est_time_coord,'String',xest1);
                        set(handles.est_angle_coord,'String',xest2);
                        set(handles.est_joint_coord,'String',xest3);
                        set(handles.dist_err_time,'String',dist_err_time);
                        set(handles.dist_err_angle,'String',dist_err_angle);
                        set(handles.dist_err_joint,'String',dist_err_joint);
                        drawnow;
                        dist_err_time_estimation(iter)=dist_err_time;
                        dist_err_angle_estimation(iter)=dist_err_angle;
                        dist_err_joint_estimation(iter)=dist_err_joint; % Matrix of N_iter x N_mu_elev_angles

                    end
                    progress=(iter*vr_az/total)*100;
                    set(handles.progress,'String',progress);
                        
                    mean_dist_err_joint_variances(vr_az)=nanmean(dist_err_joint_estimation); % Matrix of N_var_az x N_mu_az_angles
                    mean_dist_err_time_variances(vr_az)=nanmean(dist_err_time_estimation);   
                    mean_dist_err_angle_variances(vr_az)=nanmean(dist_err_angle_estimation); 
                    
                    std_dist_err_joint_variances(vr_az)=nanstd(dist_err_joint_estimation); % Matrix of N_var_az x N_mu_az_angles
                    std_dist_err_time_variances(vr_az)=nanstd(dist_err_time_estimation);    
                    std_dist_err_angle_variances(vr_az)=nanstd(dist_err_angle_estimation);    
                end
                h=figure(env_study);
                plot(var_az_vect,mean_dist_err_joint_variances,'k-X',var_az_vect,mean_dist_err_time_variances,'b-o',var_az_vect,mean_dist_err_angle_variances,'r-s');
%                 plot(var_az_vect,mean_dist_err_time_variances,'b-o',var_az_vect,mean_dist_err_angle_variances,'r-s');
                hold on 
                grid on
                legend('Joint Estimation','Time Estimation','Angle Estimation');
%                 legend('Time Estimation','Angle Estimation');
                title('Distance Error vs Azimuth Variance');
                xlabel('\theta_\alpha');
                ylabel('Average Error (m)');
                drawnow;
                
                h1=figure(env_study+6);
                plot(var_az_vect,std_dist_err_joint_variances,'k-X',var_az_vect,std_dist_err_time_variances,'b-o',var_az_vect,std_dist_err_angle_variances,'r-s');
%                 plot(var_az_vect,std_dist_err_time_variances,'b-o',var_az_vect,std_dist_err_angle_variances,'r-s');
                hold on 
                grid on
                legend('Joint Estimation','Time Estimation','Angle Estimation');
%                 legend('Time Estimation','Angle Estimation');
                title('Distance Error vs Azimuth Variance');
                xlabel('\theta_\alpha');
                ylabel('Standard Error (m)');
                drawnow;
                
                % Save the figure
                figname=horzcat('AP',num2str(N_AP),'_LOS_Avg_error.fig');
                saveas(h,fullfile(path,figname),'fig');
                figname=horzcat('AP',num2str(N_AP),'_LOS_Std_error.fig');
                saveas(h1,fullfile(path,figname),'fig');
                
        end   
        % Closing the figure for not overloading the screen. All the
        % figures are saved in its own directory.
        close(h)
        close(h1)
            
        % Reseting string for the legends
        str_cat=[];        
        

    case 5 % 'Influence of the mean value in time estimation (NLOS in time)'
        % Path where we want to save results
        mkdir('Case_5:Time_influence');
        path=[pwd '/Case_5:Time_influence/'];
        
        N_AP=AP_study;
        
        % Azimuth variance and elevation variance are constant
        var_az=var_az_ini;
        var_elev=var_elev_ini;   
        
        % Mean values
        mu_az=0;
        mu_elev=0;
        switch type_envir
            case 1 % 'NLOS'
                mu_t_ini=str2double(get(handles.mean_value_ini,'String'));
                mu_t_step=str2double(get(handles.mean_value_step,'String'));
                mu_t_fin=str2double(get(handles.mean_value_fin,'String'));
                mu_t_vect=[mu_t_ini:mu_t_step:mu_t_fin];

                % Progress
                progress=0;
                set(handles.progress,'String',progress);
                
                % Total iterations
                total=length(var_t_vect)*length(mu_t_vect)*N_iter;
                
                for vr_t=1:length(var_t_vect) 
                    var_t=var_t_vect(vr_t); 
                    if get(handles.stop,'UserData')==1
                        warndlg('FORCED EXIT');
                        display('!!!!!!!! FORCED EXIT !!!!!!!!');
                        break
                    end
                    for mu=1:length(mu_t_vect) 
                        mu_t=mu_t_vect(mu);
                        if get(handles.stop,'UserData')==1
                            break
                        end
                        for iter=1:N_iter
                            if get(handles.stop,'UserData')==1
                             break
                            end
                            
                            cla(handles.building); % reset only building axes
                            [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);

                            % Putting the results in the results text boxes
                            set(handles.AP,'String',N_AP);
                            set(handles.iteration,'String',iter);
                            set(handles.variance_time,'String',var_t);
                            set(handles.variance_azimuth_angle,'String',var_az);
                            set(handles.variance_elevation_angle,'String',var_elev);
                            set(handles.mean_time_value_interface,'String',mu_t);
                            set(handles.mean_azimuth_angle_value,'String',mu_az);
                            set(handles.mean_elevation_angle_value,'String',mu_elev);
                            set(handles.mobile_coord,'String',mvl);
                            set(handles.est_time_coord,'String',xest1);
                            set(handles.est_angle_coord,'String',xest2);
                            set(handles.est_joint_coord,'String',xest3);
                            set(handles.dist_err_time,'String',dist_err_time);
                            set(handles.dist_err_angle,'String',dist_err_angle);
                            set(handles.dist_err_joint,'String',dist_err_joint);
                            drawnow;
                            dist_err_time_estimation(iter,mu)=dist_err_time;
                            dist_err_angle_estimation(iter,mu)=dist_err_angle;
                            dist_err_joint_estimation(iter,mu)=dist_err_joint; % Matrix of N_iter x N_mu_elev_angles

                        end
                        progress=(iter*vr_t*mu/total)*100;
                        set(handles.progress,'String',progress);
                        
                    end
                    mean_dist_err_joint_variances(vr_t,:)=nanmean(dist_err_joint_estimation); % Matrix of N_var_t x N_mu_t_angles
                    mean_dist_err_time_variances(vr_t,:)=nanmean(dist_err_time_estimation);  
                    mean_dist_err_angle_variances(vr_t,:)=nanmean(dist_err_angle_estimation);  
                    
                    std_dist_err_joint_variances(vr_t,:)=nanstd(dist_err_joint_estimation); % Matrix of N_var_t x N_mu_t_angles
                    std_dist_err_time_variances(vr_t,:)=nanstd(dist_err_time_estimation);  
                    std_dist_err_angle_variances(vr_t,:)=nanstd(dist_err_angle_estimation);  
                    
                    h=figure(env_study);
%                     plot(mu_t_vect,mean_dist_err_joint_variances(vr_t,:),':',mu_t_vect,mean_dist_err_time_variances(vr_t,:),'--',mu_t_vect,mean_dist_err_angle_variances(vr_t,:),'-','LineWidth',2);
                    plot(mu_t_vect,mean_dist_err_time_variances(vr_t,:),'--',mu_t_vect,mean_dist_err_angle_variances(vr_t,:),'-','LineWidth',2);
                    hold on 
                    grid on
%                     str1=(['Time variance ', num2str(var_t_vect(vr_t)),' Joint est']);
                    str2=(['Time variance ', num2str(var_t_vect(vr_t)),'  Time est']);
                    str3=(['Time variance ', num2str(var_t_vect(vr_t)),' Angle est']);
%                     str=[str1; str2; str3];
                    str=[str2; str3];
                    if length(str)<(24+numel(num2str(var_t_step))) % Number of characters of the String we want to appear in the legend
                        diff=(24+numel(num2str(var_t_step)))-length(str);
                        rell=char(zeros(1,diff));
%                         str=[str1 rell; str2 rell; str3 rell];
                        str=[str2 rell; str3 rell];
                    end
                    str_cat=[str_cat; str];
                    legend(str_cat);
                    title('Distance Error');
                    xlabel('\mu_t');
                    ylabel('Average Error (m)');
                    drawnow;
                    
                    h1=figure(env_study+6);
%                     plot(mu_t_vect,std_dist_err_joint_variances(vr_t,:),':',mu_t_vect,std_dist_err_time_variances(vr_t,:),'--',mu_t_vect,std_dist_err_angle_variances(vr_t,:),'-','LineWidth',2);
                    plot(mu_t_vect,std_dist_err_time_variances(vr_t,:),'--',mu_t_vect,std_dist_err_angle_variances(vr_t,:),'-','LineWidth',2);
                    hold on 
                    grid on
                    legend(str_cat);
                    title('Distance Error');
                    xlabel('\mu_t');
                    ylabel('Standard Error (m)');
                    drawnow;
                    
                end
                % Save the figure
                figname=horzcat('AP',num2str(N_AP),'_NLOS_Avg_error.fig');
                saveas(h,fullfile(path,figname),'fig');
                
                figname=horzcat('AP',num2str(N_AP),'_NLOS_Std_error.fig');
                saveas(h,fullfile(path,figname),'fig');
                
                T_mean_error_joint_estimation=table(mean_dist_err_joint_variances);
                T_mean_error_time_estimation=table(mean_dist_err_time_variances);
                T_mean_error_angle_estimation=table(mean_dist_err_angle_variances);
                P=genvarname(['AP',num2str(N_AP),'_NLOS_joint_estimation_mean_error']);
                P2=genvarname(['AP',num2str(N_AP),'_NLOS_time_estimation_mean_error']);
                P3=genvarname(['AP',num2str(N_AP),'_NLOS_angle_estimation_mean_error']);
                assignin('base',P,T_mean_error_joint_estimation); % save in worksapce
                assignin('base',P2,T_mean_error_time_estimation); % save in worksapce
                assignin('base',P3,T_mean_error_angle_estimation); % save in worksapce

                writetable(T_mean_error_joint_estimation,fullfile(path,P),'Delimiter',',');
                writetable(T_mean_error_time_estimation,fullfile(path,P2),'Delimiter',',');
                writetable(T_mean_error_angle_estimation,fullfile(path,P3),'Delimiter',',');
                
                T_std_error_joint_estimation=table(std_dist_err_joint_variances);
                T_std_error_time_estimation=table(std_dist_err_time_variances);
                T_std_error_angle_estimation=table(std_dist_err_angle_variances);
                P=genvarname(['AP',num2str(N_AP),'_NLOS_joint_estimation_std_error']);
                P2=genvarname(['AP',num2str(N_AP),'_NLOS_time_estimation_std_error']);
                P3=genvarname(['AP',num2str(N_AP),'_NLOS_angle_estimation_std_error']);
                assignin('base',P,T_std_error_joint_estimation); % save in worksapce
                assignin('base',P2,T_std_error_time_estimation); % save in worksapce
                assignin('base',P3,T_std_error_angle_estimation); % save in worksapce
                
                writetable(T_std_error_joint_estimation,fullfile(path,P),'Delimiter',',');
                writetable(T_std_error_time_estimation,fullfile(path,P2),'Delimiter',',');
                writetable(T_std_error_angle_estimation,fullfile(path,P3),'Delimiter',',');

            case 2 % 'LOS'
                mu_t=0;
                
                % Progress
                progress=0;
                set(handles.progress,'String',progress);
                
                % Total iterations
                total=length(var_t_vect)*N_iter;
                
                for vr_t=1:length(var_t_vect) 
                    var_t=var_t_vect(vr_t); 
                    if get(handles.stop,'UserData')==1
                        warndlg('FORCED EXIT');
                        display('!!!!!!!! FORCED EXIT !!!!!!!!');
                        break
                    end
                    for iter=1:N_iter
                        if get(handles.stop,'UserData')==1
                         break
                        end
                        
                        cla(handles.building); % reset only building axes
                        [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);

                        % Putting the results in the results text boxes
                        set(handles.AP,'String',N_AP);
                        set(handles.iteration,'String',iter);
                        set(handles.variance_time,'String',var_t);
                        set(handles.variance_azimuth_angle,'String',var_az);
                        set(handles.variance_elevation_angle,'String',var_elev);
                        set(handles.mean_time_value_interface,'String',mu_t);
                        set(handles.mean_azimuth_angle_value,'String',mu_az);
                        set(handles.mean_elevation_angle_value,'String',mu_elev);
                        set(handles.mobile_coord,'String',mvl);
                        set(handles.est_time_coord,'String',xest1);
                        set(handles.est_angle_coord,'String',xest2);
                        set(handles.est_joint_coord,'String',xest3);
                        set(handles.dist_err_time,'String',dist_err_time);
                        set(handles.dist_err_angle,'String',dist_err_angle);
                        set(handles.dist_err_joint,'String',dist_err_joint);
                        drawnow;
                        dist_err_time_estimation(iter)=dist_err_time;
                        dist_err_angle_estimation(iter)=dist_err_angle;
                        dist_err_joint_estimation(iter)=dist_err_joint; % Matrix of N_iter x N_mu_elev_angles

                    end
                    progress=(iter*vr_t/total)*100;
                    set(handles.progress,'String',progress);
                        
                    mean_dist_err_joint_variances(vr_t)=nanmean(dist_err_joint_estimation); % Matrix of N_var_t x N_mu_t_angles
                    mean_dist_err_time_variances(vr_t)=nanmean(dist_err_time_estimation);  
                    mean_dist_err_angle_variances(vr_t)=nanmean(dist_err_angle_estimation);   
                    
                    std_dist_err_joint_variances(vr_t)=nanstd(dist_err_joint_estimation); % Matrix of N_var_t x N_mu_t_angles
                    std_dist_err_time_variances(vr_t)=nanstd(dist_err_time_estimation); 
                    std_dist_err_angle_variances(vr_t)=nanstd(dist_err_angle_estimation);   
                end
                h=figure(env_study);
                plot(var_t_vect,mean_dist_err_joint_variances,'k-x',var_t_vect,mean_dist_err_time_variances,'b-o',var_t_vect,mean_dist_err_angle_variances,'r-s');
%                 plot(var_t_vect,mean_dist_err_time_variances,'b-o',var_t_vect,mean_dist_err_angle_variances,'r-s');
                hold on 
                grid on
                legend('Joint Estimation','Time Estimation','Angle Estimation');
%                 legend('Time Estimation','Angle Estimation');
                title('Distance Error vs Time Variance');
                xlabel('\theta_t');
                ylabel('Average Error (m)');
                drawnow;
                
                h1=figure(env_study+6);
                plot(var_t_vect,std_dist_err_joint_variances,'k-x',var_t_vect,std_dist_err_time_variances,'b-o',var_t_vect,std_dist_err_angle_variances,'r-s');
%                 plot(var_t_vect,std_dist_err_time_variances,'b-o',var_t_vect,std_dist_err_angle_variances,'r-s');
                hold on 
                grid on
                legend('Joint Estimation','Time Estimation','Angle Estimation');
                title('Distance Error vs Azimuth Variance');
%                 legend('Time Estimation','Angle Estimation');
                xlabel('\theta_t');
                ylabel('Standard Error (m)');
                drawnow;
                
                % Save the figure
                figname=horzcat('AP',num2str(N_AP),'_LOS_Avg_error.fig');
                saveas(h,fullfile(path,figname),'fig');
                figname=horzcat('AP',num2str(N_AP),'_LOS_Std_error.fig');
                saveas(h1,fullfile(path,figname),'fig');
                
        end   
        % Closing the figure for not overloading the screen. All the
        % figures are saved in its own directory.
        close(h)
        close(h1)
            
        % Reseting string for the legends
        str_cat=[];
        
    case 6 % Influence of the number of AP's
        % Path where we want to save results
        mkdir('Case_6:Number_AP_influence');
        path=[pwd '/Case_6:Number_AP_influence/'];
        
      Num_AP=str2double(strsplit(get(handles.AP_vector,'String'),','));  
      var_t=var_t_ini;
      var_az=var_az_ini;
      var_elev=var_elev_ini;
      
     switch type_envir
          case 1 % NLOS
              mu_t=str2double(get(handles.mean_value_ini,'String'));
              mu_az=str2double(get(handles.mean_azimuth_ini,'String'));
              mu_elev=str2double(get(handles.mean_elevation_ini,'String'));
              
          case 2 % LOS
              mu_t=0; mu_az=0; mu_elev=0;
               
     end
      
     % Progress
    progress=0;
    set(handles.progress,'String',progress);

    % Total iterations
    total=length(Num_AP)*N_iter;

      
     for k=1:length(Num_AP)
        N_AP=Num_AP(k);
        if get(handles.stop,'UserData')==1
            warndlg('FORCED EXIT');
            display('!!!!!!!! FORCED EXIT !!!!!!!!');
            break
        end
        for iter=1:N_iter
            if get(handles.stop,'UserData')==1
             break
            end
            
            cla(handles.building); % reset only building axes
            [mvl,xest1,xest2,xest3,dist_err_time,dist_err_angle,dist_err_joint]=mobile_postion_estimation_joint_time_angles(N_AP,var_t,var_az,var_elev,mu_t,mu_az,mu_elev,v);

            % Putting the results in the results text boxes
            set(handles.AP,'String',N_AP);
            set(handles.iteration,'String',iter);
            set(handles.variance_time,'String',var_t);
            set(handles.variance_azimuth_angle,'String',var_az);
            set(handles.variance_elevation_angle,'String',var_elev);
            set(handles.mean_time_value_interface,'String',mu_t);
            set(handles.mean_azimuth_angle_value,'String',mu_az);
            set(handles.mean_elevation_angle_value,'String',mu_elev);
            set(handles.mobile_coord,'String',mvl);
            set(handles.est_time_coord,'String',xest1);
            set(handles.est_angle_coord,'String',xest2);
            set(handles.est_joint_coord,'String',xest3);
            set(handles.dist_err_time,'String',dist_err_time);
            set(handles.dist_err_angle,'String',dist_err_angle);
            set(handles.dist_err_joint,'String',dist_err_joint);
            drawnow;

            dist_err_time_estimation(iter)=dist_err_time;
            dist_err_angle_estimation(iter)=dist_err_angle;
            dist_err_joint_estimation(iter)=dist_err_joint; % Matrix of N_iter x N_mu_elev_angles
        end
 
        progress=(iter*k/total)*100;
        set(handles.progress,'String',progress);
                    
        mean_dist_err_joint_variances(k)=nanmean(dist_err_joint_estimation);
        mean_dist_err_time_variances(k)=nanmean(dist_err_time_estimation);   
        mean_dist_err_angle_variances(k)=nanmean(dist_err_angle_estimation);   

        std_dist_err_joint_variances(k)=nanstd(dist_err_joint_estimation); 
        std_dist_err_time_variances(k)=nanstd(dist_err_time_estimation);   
        std_dist_err_angle_variances(k)=nanstd(dist_err_angle_estimation);   
     end
    assignin('base','avg_error_angle',mean_dist_err_angle_variances); % save in worksapce
    assignin('base','avg_error_time',mean_dist_err_time_variances); % save in worksapce
    assignin('base','avg_error_joint',mean_dist_err_joint_variances); % save in worksapce
    assignin('base','std_error_angle',std_dist_err_angle_variances); % save in worksapce
    assignin('base','std_error_time',std_dist_err_time_variances); % save in worksapce
    assignin('base','std_error_joint',std_dist_err_joint_variances); % save in worksapce
    
    h=figure(env_study);
%     plot(Num_AP,mean_dist_err_joint_variances,'k-X',Num_AP,mean_dist_err_time_variances,'b-o',Num_AP,mean_dist_err_angle_variances,'r-s');
    plot(Num_AP,mean_dist_err_time_variances,'b-o',Num_AP,mean_dist_err_angle_variances,'r-s');
    hold on 
    grid on
%     legend('Joint Estimation','Time Estimation','Angle Estimation');
    legend('Time Estimation','Angle Estimation');
    title('Distance Error vs Number of APs');
    xlabel('AP');
    ylabel('Average Error (m)');
    drawnow;

    h1=figure(env_study+6);
%     plot(Num_AP,std_dist_err_joint_variances,'k-X',Num_AP,std_dist_err_time_variances,'b-o',Num_AP,std_dist_err_angle_variances,'r-s');
    plot(Num_AP,std_dist_err_time_variances,'b-o',Num_AP,std_dist_err_angle_variances,'r-s');
    hold on 
    grid on
%     legend('Joint Estimation','Time Estimation','Angle Estimation');
    legend('Time Estimation','Angle Estimation');
    title('Distance Error vs Number of APs');
    xlabel('AP');
    ylabel('Standard Error (m)');
    drawnow;

    % Save the figure
    if type_envir==1 % NLOS
        figname=horzcat('AP',num2str(N_AP),'_NLOS_Avg_error.fig');
        figname1=horzcat('AP',num2str(N_AP),'_NLOS_Std_error.fig');
    else
        figname=horzcat('AP',num2str(N_AP),'_LOS_Avg_error.fig');
        figname1=horzcat('AP',num2str(N_AP),'_LOS_Std_error.fig');
    end
    saveas(h,fullfile(path,figname),'fig');
    saveas(h1,fullfile(path,figname1),'fig');   
    close(h)
    close(h1)
         
end
% if get(handles.stop,'Userdata')==1,
%          return;
% end;


% % --- Executes on button press in pause.
% function pause_Callback(hObject, eventdata, handles)
% % hObject    handle to pause (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)

% --- Executes on button press in stop.
function stop_Callback(hObject, eventdata, handles)
set(handles.stop,'UserData',1); 
guidata(hObject, handles);
% stopper=1;
% hObject    handle to stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% set(handles.stop, 'Userdata',1);

%       handles = guidata(handles.fig);
% guidata(hObject,handles);
%    selection2 = questdlg('Do you want to stop the execution?',...
%       'Close Request Function',...
%       'Yes','No','Yes'); 
%    switch selection2, 
%       case 'Yes',
%          delete(gcf)
%       case 'No'
%       return 
%    end
% global true
% true=1;




% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
   selection = questdlg('Close This Figure?',...
      'Close Request Function',...
      'Yes','No','Yes'); 
   switch selection, 
      case 'Yes',
         delete(gcf)
      case 'No'
      return 
   end


% --- Executes during object creation, after setting all properties.
function mobile_coord_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mobile_coord (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
